CON
  ' overlay demo using Kyedos
  
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

  '_leftChannelVolume = 32
  '_rightChannelVolume = 32

  _baudRateSpeed = 115200 ' Teraterm does not work at this speed. Use hyperterminal or other programs
'  _newLineCharacter = 13
  _clearScreenCharacter = 16
  _homeCursorCharacter = 1

  _receiverPin = 31
  _transmitterPin = 30

  _RTC_DAT = -1 ' -1 ifnot installed.
  _RTC_CLK = -1 ' -1 ifnot installed.

  _VGA_Enabled = true ' VGA display on
  _VGA_PinGroup = 2
  VGAPin = 16

  _LCD_Enabled = false ' false or true for 20x4 LCD display
  _Serial_Enabled = true ' send output to serial port 

  _leftChannelAudioPin = -1 ' -1 ifnot installed.
  _rightChannelAudioPin = -1 ' -1 ifnot installed.

  _leftMicFeedBackPin = -1 ' -1 ifnot installed.
  _leftMicInputPin = -1 ' -1 ifnot installed.

  _rightMicFeedBackPin = -1 ' -1 ifnot installed.
  _rightMicInputPin = -1 ' -1 ifnot installed.

  _SD_DO = 15
  _SD_CLK = 14
  _SD_DI = 13
  _SD_CS = 12
  _SD_WP = -1 ' -1 ifnot installed.
  _SD_CD = -1 ' -1 ifnot installed.
  
  Quote = 34
  Horizontal_Tab = 9
  Line_Feed = 10
  Carriage_Return =13

OBJ

  fat: "SD-MMC_FATEngine_No_RTC.spin"
  taf: "SD-MMC_FATEngine_No_RTC.spin"   
  'rtc: "DS1307_RTCEngine.spin"
  'com: "RS232_COMEngine.spin"
  str: "ASCII0_STREngine.spin"
  'adc: "PCM2.1_ADCEngine.spin"
  'dac: "PCM2.1_DACEngine.spin"
  'bmp: "VGA64_BMPEngine.spin"
  VT100: "VGA_1024_VT100_Resident"       ' VGA VT100 Terminal Driver
  'key : "Pocketerm_Keyboard"           ' pocketerm keyboard
  key : "Keyboard_Resident"   ' resident part of keyboard
  'lcd : "DracLCD"                     ' 20x4 LCD driver for dracblade
  delay: "Timing"                     ' for millisecond delays
  sio     : "pcFullDuplexSerial2FC" 

VAR
'
'  long scopeSwtich, scopeStack[17], scopeHeap[((_VGA_H_Res * _VGA_V_Res) * 2) / 32]
   byte CommandLine[80] ' complete command line as typed in
   byte LineOfText1[80] ' general purpose string buffer
   byte LineOfText2[80] ' general purpose string buffer
   byte LineOfText3[80] ' general purpose string buffer

PUB shell
  sio.AddPort(0, _receiverPin, _transmitterPin, -1, -1, 0, 0, _baudRateSpeed)
  ifnot( fat.FATEngineStart(_SD_DO, _SD_CLK, _SD_DI, _SD_CS, _SD_WP, _SD_CD, _RTC_DAT, _RTC_CLK, -1))
    reboot
  sio.start             ' start the com port  note can't print anything to screen till sio.start unless only do to vga screen
  fat.mountPartition(0)     ' mount the sd card
  main ' overlay demo
  
' ****************** Begin Overlay demo code  **********************
OBJ
  ovl : "dummy"

VAR
  long firstvar

PUB main
  result := VT100.StoreParameters(VGAPin)' store parameters for vga driver on pin 16
  CallOverlay(string("VGAovl.bin"),result) ' load two cogs with VGA driver and pass location of the array
  VT100.startcursor                                     ' start the cursor
  VT100.color(%00001000_11111100)                       ' Blue_White  blue =3/4 power 10, white =full                                  
  VT100.cursorset(5)                                    ' cursor type 5
  VT100.clearscreen                                     ' clear the screen  
  printstring(string("Start Overlay Demonstration"))
  crlf
  printstring(string("VGA resident and overlay loaded"))
  crlf
  'PrintOverlayReturnValue(string("test1.bin"))
  'PrintOverlayReturnValue(string("test2.bin"))
  printstring(string("load keyboard cog"))
  crlf
  result := key.Store_Parameters(27, 26, %100, 40)             'Start Keyboard Driver  pin,pin,num,repeatrate, returns array location  
  CallOverlay(string("KeyOver.bin"),result) ' load cog with keyboard driver and pass location of the array
  'PrintOverlayReturnValue(string("test3.bin"))
  printstring(string("type something"))
  repeat
    result := key.key
    if result <>0
      printchar(result)
      

PUB PrintOverlayReturnValue(fname)
  result := CallOverlay(fname,0)
  printstring(fname)
  printstring(string(" returned a value of "))
  printdecimal(result)
  crlf

PUB CallOverlay(fname,n) | addr, size, pbase, vbase, dbase, vsize, nummet1, numobj, entryptr
  ' Load the object to a location 200 longs after the current stack pointer
  ' n is value to pass to the overlay (usually the location of an array)
  addr := @result + 800
  size := LoadFile(fname, addr)
  ifnot size
    return 0

  ' Get the values of pbase, vbase and dbase
  pbase := word[addr][3] + addr
  vbase := word[addr][4] + addr
  dbase := word[addr][5] + addr

  ' Determine the VAR size and zero it
  vsize := dbase - vbase - 8
  longfill(vbase, 0, vsize/4)

  ' Locate the method table entry for the last object
  nummet1 := byte[@@0][2]
  numobj := byte[@@0][3]
  entryptr := @@0 + (nummet1+numobj-1)*4

  ' Adjust the pbase and vbase offsets in the method table
  word[entryptr] := pbase - @@0
  word[entryptr][1] := vbase - @firstvar
  ' Call the first method in the object
  return ovl.main(n)

PUB Loadfile(fname, addr)
  fat.openfile(fname,"R")
  result := fat.readdata(addr,30000)
  fat.closefile
'************************* end overlay demo ****************************

PUB PrintStringCR(pstring)' sends pstring to the vga and serial port
     PrintString(pstring)                               ' print the string  
     crlf

PUB PrintString(pstring)' sends pstring to the vga and serial port with no CRLF
    if (_VGA_Enabled)  
      vt100.str(pstring)                                 ' send to vga screen
    if (_Serial_Enabled)   
    sio.str(0,pstring)                                 ' send to com port
    'if (_lcd_Enabled)
    '   lcd.str(pstring)                                   ' send to 20x4 lCD display

PUB PrintChar(c) ' sends c to vga and serial port
    if (_VGA_Enabled)
      vt100.out(c)                                        ' send to vga
    if (_Serial_Enabled)
      sio.tx(0,c)                                         ' send to com port
    'if (_lcd_Enabled)
    '  LCD.out(c)                                          ' send to LCD display      
PUB CRLF
    PrintChar(13)                                        ' send to vga
    PrintChar(10)                                        ' send to vga

PUB PrintDecimal(number)                                ' print the decimal value, useful for debuggin
     PrintString(str.integerToDecimal(number, 10))   
        
{{

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                  TERMS OF USE: MIT License
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation
// files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy,
// modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the
// Software is furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in all copies or substantial portions of the
// Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
// WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
// COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
// ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
}}